<template>
  <div class="page">
    <div class="container">
      <div class="page__head">
        <div class="page__title">Blog 📰</div>
        <BlogSort/>
      </div>
      <div class="page__content" v-if="dataBlogs && dataBlogs.length">
        <div class="page__row">
          <BlogCard v-for="item in (dataBlogs as Post[])" :key="item.id" v-bind="item"/>
        </div>
        <div class="page__pagination">
          <UiPagination
              :current-page="$route.query._page ? parseInt($route.query._page as string) : 1"
              :total-pages="totalPages"
              @page-change="changePage"
          ></UiPagination>
        </div>
      </div>
      <BlogEmpty v-else/>
    </div>
  </div>
</template>
<script setup lang="ts">
const currentPage = ref(1)
const totalPages = ref(0)
const limit = ref(15)
const dataBlogs = ref<Post[] | null>(null)
const {push, currentRoute} = useRouter()

type Post = {
  userId: number
  id: string
  title: string
  body: string
}
const changePage = (page: number) => {
  push({query: {...currentRoute.value.query, _page: page}})
}
const loadData = async (args: any) => {
  const data = await $fetch('https://ax-technology-api.vercel.app/posts', {
      params: {
        _sort: 'title', _order: "asc",
        _page: currentPage.value,
        ...args,
      },
      onResponse(context) {
        const link = context.response.headers.get('link');
        if (link) {
            totalPages.value = useParseLinkHeader(link);
        }else {
          totalPages.value = 0
        }
      }
    }
  )
  dataBlogs.value = data as Post[]
}
await loadData(currentRoute.value.query)

onBeforeRouteUpdate((to, from) => {
  loadData(to.query)
})

definePageMeta({
  layout: 'base',
})
useHead({
  title: 'Blog',
  meta: [
    {
      name: 'description',
      content: 'Blog page',
    },
  ],
})
</script>